/* Copyright 2005 Matt Flax <flatmax@ieee.org>
   This file is part of MFFM GTK wrapper class set

   MFFM GTK wrapper class set is free software; you can redistribute
   it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   MFFM GTK wrapper class set is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You have received a copy of the GNU General Public License
   along with MFFM GTK wrapper class set
 */
#ifndef LABELBUTTONS_H_
#define LABELBUTTONS_H_

#include <iomanip>
#include <gtk/gtk.h>
#include <LinkList.H>

class nameFuncData {
public:
  char *str;
  void (*func)(void *arg1, void *arg2);
  void *data;
};
#define LABELBUTTONSSTRUCT (nameFuncData)

class LabelButtons : public LinkList<GtkWidget *> {
public:
  LabelButtons& operator <<(nameFuncData nf) {
    LinkList<GtkWidget *>::add(gtk_button_new_with_label(nf.str));
    gtk_signal_connect(GTK_OBJECT(current()), "clicked",GTK_SIGNAL_FUNC(nf.func), nf.data);
    gtk_widget_show(current());
    return *this;
  }
};
#endif //LABELBUTTONS_H_
